- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes | List of all members
subst_constraint_action Class Reference

Detect and process implied free variables. More...

`#include <CoinPresolveSubst.hpp>`

Inheritance diagram for subst_constraint_action:
[legend]
Collaboration diagram for subst_constraint_action:
[legend]

## Classes
struct | action

## Public Member Functions
const char * | name () const
| A name for debug printing. More...
void | postsolve (CoinPostsolveMatrix *prob) const
| Apply the postsolve transformation for this particular presolve action. More...
virtual | ~subst_constraint_action ()
Public Member Functions inherited from CoinPresolveAction
| CoinPresolveAction (const CoinPresolveAction *next)
| Construct a postsolve object and add it to the transformation list. More...
void | setNext (const CoinPresolveAction *nextAction)
| modify next (when building rather than passing) More...
virtual | ~CoinPresolveAction ()
| Virtual destructor. More...

## Static Public Member Functions
static const CoinPresolveAction * | presolve (CoinPresolveMatrix *prob, const int *implied_free, const int *which, int numberFree, const CoinPresolveAction *next, int fill_level)
static const CoinPresolveAction * | presolveX (CoinPresolveMatrix *prob, const CoinPresolveAction *next, int fillLevel)
Static Public Member Functions inherited from CoinPresolveAction
static void | throwCoinError (const char *error, const char *ps_routine)
| Stub routine to throw exceptions. More...

## Private Member Functions
| subst_constraint_action ()
| subst_constraint_action (const subst_constraint_action &rhs)
subst_constraint_action & | operator= (const subst_constraint_action &rhs)
| subst_constraint_action (int nactions, action *actions, const CoinPresolveAction *next)

## Private Attributes
const int | nactions_
const action *const | actions_

## Additional Inherited Members
Public Attributes inherited from CoinPresolveAction
const CoinPresolveAction * | next
| The next presolve transformation. More...

## Detailed Description

Detect and process implied free variables.

Consider a variable x. Suppose that we can find an equality such that the bound on the equality, combined with the bounds on the other variables involved in the equality, are such that even the worst case values of the other variables still imply bounds for x which are tighter than the variable's original bounds. Since x can never reach its upper or lower bounds, it is an implied free variable. By solving the equality for x and substituting for x in every other constraint entangled with x, we can make x into a column singleton. Now x is an implied free column singleton and both x and the equality can be removed.

A similar transform for the case where the variable is a natural column singleton is handled by implied_free_action. In the current presolve architecture, implied_free_action is responsible for detecting implied free variables that are natural column singletons or can be reduced to column singletons. implied_free_action calls subst_constraint_action to process variables that must be reduced to column singletons.

Definition at line 37 of file CoinPresolveSubst.hpp.

## Constructor & Destructor Documentation

subst_constraint_action::subst_constraint_action | ( |  | ) |
| private

subst_constraint_action::subst_constraint_action | ( | const subst_constraint_action & | rhs | ) |
| private

subst_constraint_action::subst_constraint_action | ( | int | nactions,
|  | action * | actions,
|  | const CoinPresolveAction * | next
| ) |  |
| inline private

Definition at line 65 of file CoinPresolveSubst.hpp.

virtual subst_constraint_action::~subst_constraint_action | ( |  | ) |
| virtual

## Member Function Documentation

subst_constraint_action& subst_constraint_action::operator= | ( | const subst_constraint_action & | rhs | ) |
| private

const char* subst_constraint_action::name | ( |  | ) | const
| virtual

A name for debug printing.

It is expected that the name is not stored in the transform itself.

Implements CoinPresolveAction.

static const CoinPresolveAction* subst_constraint_action::presolve | ( | CoinPresolveMatrix * | prob,
|  | const int * | implied_free,
|  | const int * | which,
|  | int | numberFree,
|  | const CoinPresolveAction * | next,
|  | int | fill_level
| ) |  |
| static

static const CoinPresolveAction* subst_constraint_action::presolveX | ( | CoinPresolveMatrix * | prob,
|  | const CoinPresolveAction * | next,
|  | int | fillLevel
| ) |  |
| static

void subst_constraint_action::postsolve | ( | CoinPostsolveMatrix * | prob | ) | const
| virtual

Apply the postsolve transformation for this particular presolve action.

Implements CoinPresolveAction.

## Member Data Documentation

const int subst_constraint_action::nactions_
| private

Definition at line 61 of file CoinPresolveSubst.hpp.

const action* const subst_constraint_action::actions_
| private

Definition at line 63 of file CoinPresolveSubst.hpp.

The documentation for this class was generated from the following file:

- /tmp/CHiPPS-Blis-0.94.3/CoinUtils/src/CoinPresolveSubst.hpp